<!DOCTYPE html>
<html lang="">

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Lanterne Rouge</title>
    <style>
        body {
            padding: 0;
            margin: 0;
        }
    </style>
    <link rel="stylesheet" href="./static/style.css">
    <link href="https://fonts.googleapis.com/css?family=Josefin+Sans:400,700" rel="stylesheet">

    <script src="./p5/p5.min.js"></script>
    <script src="./p5/addons/p5.dom.min.js"></script>
    <script src="./p5/addons/p5.sound.min.js"></script>


    <script src="./js/gui.js"></script>
    <script src="./js/cards.js"></script>
    <script src="./js/ai.js"></script>
    <script src="./js/model.js"></script>
    <script src="./js/main.js"></script>
    <script src="./js/track.js"></script>
    <script src="./js/rider.js"></script>
    <script src="./js/trackConfig.js"></script>
</head>

<body>
    <div class="top">
        <div class="header">
            <h1>LANTERNE ROUGE</h1>

            <div class="endRound">
                <h3 id="track-name"></h3>
                <h3 class="roundCounter" id="roundCounter"></h3>
            </div>
        </div>

    </div>

    <div class="form-container">
        <div class="start-form" id="settings">
            <form>
                <p>
                    Player Color:
                    <div>
                        <input type="radio" name="player-color" value="Red" checked> Red
                        <input type="radio" name="player-color" value="Green"> Green
                        <input type="radio" name="player-color" value="Blue"> Blue
                        <input type="radio" name="player-color" value="Black"> Black
                    </div>
                </p>
                <div>
                    Length of tour: <span id="track-counter"></span> track(s)
                </div>
                <p>
                    <input class="slider" id="input-track-num" name="track-num" type="range" min="1" max="10" value="3">
                </p>
                <button class="button" type="button" value="Start!" onclick="getSettings();">Start!</button>
            </form>
        </div>
    </div>



    <div class="game" id="game" hidden>
        
        <div class="cards">
            <button class="alt-button" id="myRaceBtn">View Race Standing</button>
            <button class="alt-button" id="myTourBtn">View Tour Standing</button>
            <button class="alt-button" id="myRulesBtn">View Rules</button>
        </div>
        <!-- Trigger/Open The Modal -->

        <div class="cards">
            <div class="frame">
                <div class="info">
                    <h3 id="sInfo"></h3>
                    <button id="mySBtn" class="button">Reveal Sprinteur Cards</button>
                </div>
            </div>

            <!-- The Modal -->
            <div id="mySprinteurModal" class="modal">
                <!-- Modal content -->
                <div class="modal-content">
                    <div class="sCards">
                        <button class="card" id="s0" onclick="getPlayerChoice(2, this.innerHTML)"></button>
                        <button class="card" id="s1" onclick="getPlayerChoice(2, this.innerHTML)"></button>
                        <button class="card" id="s2" onclick="getPlayerChoice(2, this.innerHTML)"></button>
                        <button class="card" id="s3" onclick="getPlayerChoice(2, this.innerHTML)"></button>
                    </div>
                </div>
            </div>

            <!-- Trigger/Open The Modal -->
            <div class="frame">
                <div class="info">
                    <h3 id="rInfo"></h3>
                    <button id="myRBtn" class="button">Reveal Rouleur Cards</button>
                </div>
            </div>

            <!-- The Modal -->
            <div id="myRouleurModal" class="modal">
                <!-- Modal content -->
                <div class="modal-content">
                    <div class="rCards">
                        <button class="card" id="r0" onclick="getPlayerChoice(1, this.innerHTML)"></button>
                        <button class="card" id="r1" onclick="getPlayerChoice(1, this.innerHTML)"></button>
                        <button class="card" id="r2" onclick="getPlayerChoice(1, this.innerHTML)"></button>
                        <button class="card" id="r3" onclick="getPlayerChoice(1, this.innerHTML)"></button>
                    </div>
                </div>
            </div>
        </div>
        
        <div class="info">
            <div id="report"></div>
        </div>
        
        <div id="gameBoard"></div>


        <!-- The Modal -->
        <div id="myRaceModal" class="modal">
            <!-- Modal content -->
            <div class="modal-content">
                <div class="form-container">
                    <div class="start-form">
                        <p>Race Standing:</p>
                        <div id="finalResult"></div>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <div id="myTourModal" class="modal">
        <!-- Modal content -->
        <div class="modal-content">
            <div class="form-container">
                <table class="start-form" id="standing-board" hidden>
                    <thead>
                        <tr>
                            <th>Name</th>
                            <th>Medals</th>
                            <th>Points</th>
                        </tr>
                    </thead>
                    <tbody>
                        <tr>
                            <td id="standing1"></td>
                            <td id="points1"></td>
                            <td id="medals1"></td>
                        </tr>
                        <tr>
                            <td id="standing2"></td>
                            <td id="points2"></td>
                            <td id="medals2"></td>
                        </tr>
                        <tr>
                            <td id="standing3"></td>
                            <td id="points3"></td>
                            <td id="medals3"></td>
                        </tr>
                        <tr>
                            <td id="standing4"></td>
                            <td id="points4"></td>
                            <td id="medals4"></td>
                        </tr>
                        <tr>
                            <td id="standing5"></td>
                            <td id="points5"></td>
                            <td id="medals5"></td>
                        </tr>
                        <tr>
                            <td id="standing6"></td>
                            <td id="points6"></td>
                            <td id="medals6"></td>
                        </tr>
                        <tr>
                            <td id="standing7"></td>
                            <td id="points7"></td>
                            <td id="medals7"></td>
                        </tr>
                        <tr>
                            <td id="standing8"></td>
                            <td id="points8"></td>
                            <td id="medals8"></td>
                        </tr>
                    </tbody>
                </table>
            </div>
        </div>
    </div>

    <!-- The Modal -->
    <div id="myRulesModal" class="modal">
        <!-- Modal content -->
        <div class="modal-content">
            <div class="form-container">
                <div class="start-form">
                    <h2>Rules:</h2>
                    <h3>Overview:</h3>
                    <p>
                        Flamme Rouge is a bicycle racing game where each player controls two riders: a Rouleur(r) a Sprinteur(s). 
                        The players' goal is to be the first to cross the finish line with one of their riders.
                        The setup is done automatically and the track is chosen randomly from a number of available tracks.
                    </p>
                    <h3>Playing the game:</h3>
                    <p>
                        Four cards are drawn for each rider and the player chooses 1 card from each hand. The card represents the
                        number of squared the selected rider can move that round. Once this is done, the riders are 
                        moved according to the rules of the game. Once the cards have been chosen, player controlled riders are moved,
                        followed by AI-contolled ones. Once that is done, slipstreaming and exhausion is applied.
                    </p>
                    <p>
                        * A rider cannot be moved into a position occupied by another rider.
                    </p>
                    <p>
                        * A rider shall always be moved to the right-hand lane.
                    </p>
                    <h3>Slipstreaming and Exhaustion</h3>
                    <p>
                        Slipstreaming is done by moving each pack (one or more riders with no empty spaces between them) of riders 
                        one square forward if the distance to the next pack is exactly 1 square.
                    </p>
                    <p>
                        After slipstreaming has been applied, every rider in the head of its pack (in both left and right lane) receives
                        an exhausiton card (a 2-card with red background). The exhaustion cards are used like the regular 2-cards.
                    </p>
                    <h3>Mountains and Downhill</h3>
                    <p>
                        In addition to the regular (grey) squares, there are mountain areas (red) and downhill areas (blue). These
                        change the way riders can move.
                    </p>
                    <p>
                        Mountain: a rider starting on, moving onto or going across any red square can never move more than 5 squares.
                        A higher value vard can be played, but its value is capped at 5 and excess moves are wasted. Additionally,
                        a rider on a red sqare can neither give nor receive slipstreaming.
                    </p>
                    <p>
                        Downhill: if a rider starts a turn on a blue square, his card always counts as a minimun og 5. A lower value 
                        can be played, but its values is always a minimum 5. Slipstreaming is awarded as normal.
                    </p>
                    <h3>Tour and Points</h3>
                    <p>
                        When playing more than one stage, the final placement of riders on each track will give points that count
                        towards the overall standing in the tour. The points are distributed as follows:
                    </p>
                    <p>
                        Winner: 3 points, 2nd place: 2 points, 3rd place: 1 point.
                    </p>


                    <h4>Attribution:</h4>
                    <p>The original board game, Flamme Rouge, was designed by Asger Harding Granerud and published by Lautapelit.fi</p>
                    <p>
                        <a target="_blank" href="https://www.vecteezy.com/">Vector Art by Vecteezy.com</a>
                    </p>
                    <p>
                        Header Image obtained from CorVos/PezCyclingNews
                    </p>
                    <h4>If you enjoy this game, please consider buying the amazing board game this one is based on!</h4>
                </div>
            </div>
        </div>
    </div>


</body>
<script>
    var slider = document.getElementById("input-track-num");
    var output = document.getElementById("track-counter");
    output.innerHTML = slider.value; // Display the default slider value

    // Update the current slider value (each time you drag the slider handle)
    slider.oninput = function () {
        output.innerHTML = this.value;
    }
</script>

<script>
    // Get the modal
    var sModal = document.getElementById('mySprinteurModal');
    var rModal = document.getElementById('myRouleurModal');
    var raceModal = document.getElementById('myRaceModal');
    var tourModal = document.getElementById('myTourModal');
    var rulesModal = document.getElementById('myRulesModal');


    // Get the button that opens the modal
    var sBtn = document.getElementById("mySBtn");
    var rBtn = document.getElementById("myRBtn");
    var rulesBtn = document.getElementById("myRulesBtn");
    var raceStandingBtn = document.getElementById("myRaceBtn");
    var tourStandingBtn = document.getElementById("myTourBtn");


    // When the user clicks on the button, open the modal
    sBtn.onclick = function () {
        sModal.style.display = "block";
    }
    rBtn.onclick = function () {
        rModal.style.display = "block";
    }
    raceStandingBtn.onclick = function () {
        raceModal.style.display = "block";
    }
    tourStandingBtn.onclick = function () {
        tourModal.style.display = "block";
    }
    rulesBtn.onclick = function () {
        rulesModal.style.display = "block";
    }

    window.onclick = function (event) {
        if (event.target == raceModal) {
            raceModal.style.display = "none";
        } else if (event.target == tourModal && !tourFinished) {
            tourModal.style.display = "none";
        } else if (event.target == rulesModal) {
            rulesModal.style.display = "none";
        }
    }
</script>


</html>